/* $Id: nws_visu.c,v 1.1.1.1 2002/02/08 00:23:42 mquinson Exp $ */

#include <stdio.h>       /* printf() */
#include <stdlib.h>      /* atoi() */
#include <string.h>      /* string functions */
#include <strings.h>     /* strncasecmp() on aix */
#include <unistd.h>      /* getopt() */

#include "nws_api.h"     /* NWS programming interface */
#include "diagnostic.h"  /* ABORT() */

#include "jval.h"
#include "jrb.h"

#include "machines_cliques.h" /* machines and cliques sets */
#include "layout.h"           /* compute hosts' place in visualization space */
#include "render.h"           /* my stuff about openGL & cichild */
#include "cichlid_server.h"   /* cichlid */

char *nameServer=NULL;
int fake=1;

/*====[ Generic functions ]==================================================*/

/*----[ usage_show ]---------------------------------------------------------*/
/* Prints usage out, and exit with #retCode# value.                          */
/*---------------------------------------------------------------------------*/ 
void usage_show(char *msg,int retCode) {
  if (msg) printf("nws_visu: %s\n",msg);
  printf("Usage: nws_visu <cichlid options> -- [-N nameserver | -f]\n"
	 "Options:\n"
	 "  -N nameserver give the hostname on which to contact the nameserver\n"
	 "  -f            fake. Do not contact anyone.\n");
  exit(retCode);
}

int main(int argc, char **argv) {
  extern char *optarg;
  extern int optind;
  int opt;
  
  DirectDiagnostics(DIAGDEBUG, stdout);
  DirectDiagnostics(DIAGINFO, stdout);
  DirectDiagnostics(DIAGLOG, stdout);
  DirectDiagnostics(DIAGWARN, stderr);
  DirectDiagnostics(DIAGERROR, stderr);
  DirectDiagnostics(DIAGFATAL, stderr);
  
  dsInit(&argc,argv,0);
  while((opt = getopt(argc, argv, "N:f")) != EOF) {

    switch(opt) {
      
    case 'N':
      nameServer = strdup(optarg);
      if (nameServer == NULL) {
        fprintf(stderr, "Out of memory\n");
        exit(1);
      }
      break;

    case 'f':
      fake = 1;
      break;

    default:
      usage_show("unrecognized switch",1);

    }
  }

  /* compute the layout */
  if (!layout_compute())  exit(1);

  //machines_display();
  //machines_dump(machines);
  render(argc,argv,fake);
  return 0; /* never reached */
  
}
