/* $Id: settings.h,v 1.2 2002/02/08 02:54:41 mquinson Exp $ */

/* settings - some constants used during the layout computation & rendering  */
/* Author: Martin Quinson                                                    */
/* License: LGPL                                                             */

/* coefficient to the weight the leader of a clique gains from it's clique 
   slaves while computing the layout of the upper clique */
#define WEIGHT_UPPER_LEVEL_MAGNIFICATION .5

/* increase decrease the radius */
#define RADIUS_MAGNIFICATION 1.5

/* coefficient applied to deform the visualization space */
#define MAGNIFICATION_X 1
#define MAGNIFICATION_Y MAGNIFICATION_X
#define MAGNIFICATION_Z 20

/* Minimal time between two redraw is */
#define SLICE_MSEC 1000

/* reask the NWS nameserver for existing cliques, and redo the layout each N 
   steps (see also SLICE_MSEC) */
#define COMPUTE_LAYOUT_EVERY_N_STEP 6

/* Maximum amount of edges/vertices (cichlid wants static allocation) */
#define MAX_VERTICES 500
#define MAX_EDGES    500

/* display space dimensions (min=0) */
#define MAX_X 1000
#define MAX_Y 1000
#define MAX_Z 1000

/* Some globals */
extern char *nameServer;
extern int fake;


#ifndef MIN
#define MIN(a,b) ((a) < (b) ? (a):(b))
#endif
