/*****************************************************************************/
/* Fonction de calcul de dgrade (bi-teinte)                                */
/*****************************************************************************/
static void degrad2t(float indice, unsigned char* color)
{

    if (indice<=0.5)
	{
	    color[0]=255-(255*(1-indice/(0.5)));	    
	    color[2]=255;
	}
    else
	{
	    color[2]=255*(1-indice);
	    color[0]=255;
	};
}

/*****************************************************************************/
/* Fonction de calcul de dgrade                                            */
/*****************************************************************************/
static void degrad1t(double indice, unsigned char* color)
{
  int minR=0;
  int maxR=0;
  int minG=17;
  int maxG=255;
  int minB=0;
  int maxB=43;

  color[0]=indice*(maxR-minR);
  color[1]=indice*(maxG-minG);
  color[2]=indice*(maxB-minB);

}

void coordgrid (int n,int *nbrow, int *nbcol) 
{
  long d = 3;
  int i = 0,j;
  long nbp;
  int facteur[15];

  *nbrow=1;
  *nbcol=1;
  nbp=(long)n;
  
  while (nbp % 2 == 0) {
    facteur[i++] = 2;
    nbp = nbp / 2;
  }
  while (d * d <= nbp)
    if (nbp % d == 0) {
      facteur[i++] = d;
      nbp = nbp / d;
    }
    else
      d = d + 2;
  if (nbp > 1)
    facteur[i++] = nbp;

  for (j=i-1;j>-1;j--) 
    {
      printf("%d\n",j);
      if (*nbrow<*nbcol) 
      	*nbrow=*nbrow*facteur[j];
      else *nbcol=*nbcol*facteur[j];
    }
}

